/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package model;

/**
 * Una sequenza generica
 * @author Gianni
 */
public interface Sequenza<T> {
  /**
   * il dato viene inserito alla posizione i
   * @param dato da memorizzare
   * @param i posizione
   */  
  void inserisci(T dato, int i);  
  /**
   * il dato viene memorizzato dopo l'ultimo
   * @param dato da memorizzare
   */
  void appendi(T dato);
  /**
   * rimuove il dato alla posizione i
   * @param i posizione da cui rimuovere
   */
  void elimina(int i);
  /**
   * ottieni il dato alla posizione i
   * @param i posizione da ottenere il dato
   * @return il dato ottenuto
   */
  T getElemento(int i);
  /**
   * test se la sequenza  vuota
   * @return true se vuota, false in caso contrario
   */
  boolean isEmpty();
  /**
   * la lunghezza della sequenza
   * @return il numero di dati presenti
   */
  int getLunghezza();
}
