/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package control;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.Insieme;
import model.InsiemeSequenzaIter;

/**
 *
 * @author Gianni
 */
public class GestoreEventiIter extends GestoreEventi {
  private InsiemeSequenzaIter<String> soci;
//  private Insieme<String> presenti[];  //in realt vedi poi che non uso questo ma un array di Object
  private Object presentiObj[] = new Object[presentiFilename.length];
//  private InsiemeSequenzaIter<String> presenti[];
  public GestoreEventiIter(){
    Scanner lettore;
    //carica da file i dati dei soci
    try {
      lettore = new Scanner(new File(path+sociFilename));
      soci = new InsiemeSequenzaIter<String>();
      while (lettore.hasNext()){
        soci.includi(lettore.nextLine());
      }
      System.out.println("Soci="+soci);
    } catch (FileNotFoundException ex) {
      System.out.println("File soci non trovato in GestoreEventiIter:"+ex);
    }
    //carica da file i dati dei presenti
//    presenti= (InsiemeSequenzaIter<String>[])new Object[presentiFilename.length];  //non si pu fare, porta errore java.lang.ClassCastException: [Ljava.lang.Object; cannot be cast to [Lmodel.InsiemeSequenzaIter;
//    presenti= (InsiemeSequenzaIter<String>[]) presentiObj; //nemmeno questa  possibile, porta a stesso errore
    for (int i = 0; i < presentiFilename.length; i++) {
      presentiObj[i]=new InsiemeSequenzaIter<String>();
      try {
        String filename = presentiFilename[i];
        lettore = new Scanner(new File(path+filename));
        //Elenco dei presenti all'evento i
        while (lettore.hasNext()){
          ((InsiemeSequenzaIter<String>)presentiObj[i]).includi(lettore.nextLine()); 
        } 
        System.out.println("Presenti["+i+"]="+presentiObj[i]);
      } catch (FileNotFoundException ex) {
        System.out.println("File presenti non trovato in GestoreEventiIter:"+ex);
      }
    }

  }
  public void quesitoA(){
    System.out.println("* Quesito B3.A");
    for (int i = 0; i < presentiObj.length; i++) {
      System.out.println("Elenco dei non soci presenti all'evento "+i);
      for (String presente:(InsiemeSequenzaIter<String>)presentiObj[i]){
        if (!soci.appartiene(presente)){
          System.out.println(presente);
        } 
      }       
    } 
  }
  public void quesitoB(){
    //insieme dei soci da cui caver i presenti
    Insieme<String> sociAssenti = soci.clone();
    System.out.println("* Quesito B3.B");
    for (int i = 0; i < presentiObj.length; i++) {
      //soci presenti all'evento i
      for (String presente:(InsiemeSequenzaIter<String>)presentiObj[i]){
        sociAssenti.escludi(presente);
      }       
    }
    //confronto con i soci
    System.out.println("Elenco dei soci non presenti ad alcun evento ");
    for (String assente:soci){
      if (sociAssenti.appartiene(assente)){
        System.out.println(assente);
      } 
    }       
  }
}
